diff -ruN strongswan-5.8.4/src/libstrongswan/credentials/keys/public_key.c strongswancont-5.8.4-svc/src/libstrongswan/credentials/keys/public_key.c
--- strongswan-5.8.4/src/libstrongswan/credentials/keys/public_key.c	2018-12-14 18:48:24.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/credentials/keys/public_key.c	2023-04-30 13:34:32.646541000 +0300
@@ -20,17 +20,18 @@
 #include "public_key.h"
 #include "signature_params.h"
 
-ENUM(key_type_names, KEY_ANY, KEY_BLISS,
+ENUM(key_type_names, KEY_ANY, KEY_BIGN,
 	"ANY",
 	"RSA",
 	"ECDSA",
 	"DSA",
 	"ED25519",
 	"ED448",
-	"BLISS"
+	"BLISS",
+	"BIGN",
 );
 
-ENUM(signature_scheme_names, SIGN_UNKNOWN, SIGN_BLISS_WITH_SHA3_512,
+ENUM(signature_scheme_names, SIGN_UNKNOWN, SIGN_BIGN_WITH_HBELT,
 	"UNKNOWN",
 	"RSA_EMSA_PKCS1_NULL",
 	"RSA_EMSA_PKCS1_MD5",
@@ -60,6 +61,7 @@
 	"BLISS_WITH_SHA3_256",
 	"BLISS_WITH_SHA3_384",
 	"BLISS_WITH_SHA3_512",
+	"BIGN_WITH_HBELT",
 );
 
 ENUM(encryption_scheme_names, ENCRYPT_UNKNOWN, ENCRYPT_RSA_OAEP_SHA512,
@@ -176,6 +178,8 @@
 			return SIGN_BLISS_WITH_SHA3_384;
 		case OID_BLISS_WITH_SHA3_256:
 			return SIGN_BLISS_WITH_SHA3_256;
+		case OID_HASH_BELT:
+			return SIGN_BIGN_WITH_HBELT;
 	}
 	return SIGN_UNKNOWN;
 }
@@ -240,6 +244,8 @@
 			return OID_BLISS_WITH_SHA3_384;
 		case SIGN_BLISS_WITH_SHA3_512:
 			return OID_BLISS_WITH_SHA3_512;
+		case SIGN_BIGN_WITH_HBELT:
+			return OID_HASH_BELT;
 	}
 	return OID_UNKNOWN;
 }
@@ -376,6 +382,8 @@
 		case SIGN_BLISS_WITH_SHA3_384:
 		case SIGN_BLISS_WITH_SHA3_512:
 			return KEY_BLISS;
+		case SIGN_BIGN_WITH_HBELT:
+			return KEY_BIGN;
 	}
 	return KEY_ANY;
 }
diff -ruN strongswan-5.8.4/src/libstrongswan/credentials/keys/public_key.h strongswancont-5.8.4-svc/src/libstrongswan/credentials/keys/public_key.h
--- strongswan-5.8.4/src/libstrongswan/credentials/keys/public_key.h	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/credentials/keys/public_key.h	2022-07-06 15:47:34.754983000 +0300
@@ -49,6 +49,8 @@
 	KEY_ED448   = 5,
 	/** BLISS */
 	KEY_BLISS = 6,
+	/** BIGN pub key */
+	KEY_BIGN = 7,
 };
 
 /**
@@ -122,6 +124,8 @@
 	SIGN_BLISS_WITH_SHA3_384,
 	/** BLISS with SHA-3_512                                           */
 	SIGN_BLISS_WITH_SHA3_512,
+	/** STB 34.101.45 signature with Belt-HASH 						   */
+	SIGN_BIGN_WITH_HBELT,
 };
 
 /**
diff -ruN strongswan-5.8.4/src/libstrongswan/credentials/keys/shared_key.c strongswancont-5.8.4-svc/src/libstrongswan/credentials/keys/shared_key.c
--- strongswan-5.8.4/src/libstrongswan/credentials/keys/shared_key.c	2018-10-23 20:03:28.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/credentials/keys/shared_key.c	2023-06-12 15:58:29.299989000 +0300
@@ -77,7 +77,7 @@
 {
 	if (ref_put(&this->ref))
 	{
-		free(this->key.ptr);
+		chunk_clear(&this->key);
 		free(this);
 	}
 }
diff -ruN strongswan-5.8.4/src/libstrongswan/credentials/keys/signature_params.c strongswancont-5.8.4-svc/src/libstrongswan/credentials/keys/signature_params.c
--- strongswan-5.8.4/src/libstrongswan/credentials/keys/signature_params.c	2018-12-14 18:48:24.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/credentials/keys/signature_params.c	2022-07-06 15:47:34.778983000 +0300
@@ -322,7 +322,11 @@
 			case RSASSA_PSS_PARAMS_SALT_LEN:
 				if (object.len)
 				{
-					params->salt_len = (size_t)asn1_parse_integer_uint64(object);
+					params->salt_len = (ssize_t)asn1_parse_integer_uint64(object);
+					if (params->salt_len < 0)
+					{
+						goto end;
+					}
 				}
 				break;
 			case RSASSA_PSS_PARAMS_TRAILER:
diff -ruN strongswan-5.8.4/src/libstrongswan/credentials/sets/cert_cache.c strongswancont-5.8.4-svc/src/libstrongswan/credentials/sets/cert_cache.c
--- strongswan-5.8.4/src/libstrongswan/credentials/sets/cert_cache.c	2018-10-04 00:35:17.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/credentials/sets/cert_cache.c	2023-03-23 12:40:31.012143000 +0300
@@ -151,7 +151,7 @@
 	for (try = 0; try < REPLACE_TRIES; try++)
 	{
 		/* replace a random relation */
-		offset = random();
+		offset = random() % CACHE_SIZE;
 		for (i = 0; i < CACHE_SIZE; i++)
 		{
 			rel = &this->relations[(i + offset) % CACHE_SIZE];
diff -ruN strongswan-5.8.4/src/libstrongswan/crypto/crypters/crypter.c strongswancont-5.8.4-svc/src/libstrongswan/crypto/crypters/crypter.c
--- strongswan-5.8.4/src/libstrongswan/crypto/crypters/crypter.c	2019-11-28 23:30:39.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/crypto/crypters/crypter.c	2022-07-06 15:47:34.806984000 +0300
@@ -47,14 +47,26 @@
 	"CAMELLIA_CCM_12",
 	"CAMELLIA_CCM_16",
 	"CHACHA20_POLY1305");
-ENUM_NEXT(encryption_algorithm_names, ENCR_UNDEFINED, ENCR_AES_ECB, ENCR_CHACHA20_POLY1305,
+ENUM_NEXT(encryption_algorithm_names, ENCR_GOST28147_CFB_LEGACY, ENCR_BELT_CTR_LEGACY, ENCR_CHACHA20_POLY1305,
+	"GOST28147_CFB_LEGACY",
+	"BELT_CBC_LEGACY",
+	"BELT_CFB_LEGACY",
+	"BELT_CTR_LEGACY");
+ENUM_NEXT(encryption_algorithm_names, ENCR_UNDEFINED, ENCR_AES_ECB, ENCR_BELT_CTR_LEGACY,
 	"UNDEFINED",
 	"DES_ECB",
 	"SERPENT_CBC",
 	"TWOFISH_CBC",
 	"RC2_CBC",
 	"AES_ECB");
-ENUM_END(encryption_algorithm_names, ENCR_AES_ECB);
+ENUM_NEXT(encryption_algorithm_names, ENCR_GOST28147_CTR, ENCR_GOST28147_CTR_LEGACY, ENCR_AES_ECB,
+	"GOST28147_CTR",
+	"GOST28147_CFB",
+	"BELT_CBC",
+	"BELT_CFB",
+	"BELT_CTR",
+	"GOST28147_CTR_LEGACY");
+ENUM_END(encryption_algorithm_names, ENCR_GOST28147_CTR_LEGACY);
 
 /*
  * Described in header.
@@ -98,6 +110,26 @@
 			alg = ENCR_CAMELLIA_CBC;
 			alg_key_size = 256;
 			break;
+		case OID_GOST28147_CTR:
+			alg = ENCR_GOST28147_CTR;
+			alg_key_size = 256;
+			break;
+		case OID_GOST28147_CFB:
+			alg = ENCR_GOST28147_CFB;
+			alg_key_size = 256;
+			break;
+		case OID_BELT_CBC:
+			alg = ENCR_BELT_CBC;
+			alg_key_size = 256;
+			break;		
+		case OID_BELT_CFB:
+			alg = ENCR_BELT_CFB;
+			alg_key_size = 256;
+			break;		
+		case OID_BELT_CTR:
+			alg = ENCR_BELT_CTR;
+			alg_key_size = 256;
+			break;		
 		case OID_BLOWFISH_CBC:
 			alg = ENCR_BLOWFISH;
 			alg_key_size = 0;
@@ -160,6 +192,26 @@
 					oid = OID_UNKNOWN;
 			}
 			break;
+		case ENCR_GOST28147_CTR_LEGACY:
+		case ENCR_GOST28147_CTR:
+			oid = OID_GOST28147_CTR;
+			break;
+		case ENCR_GOST28147_CFB_LEGACY:
+		case ENCR_GOST28147_CFB:
+			oid = OID_GOST28147_CFB;
+			break;
+		case ENCR_BELT_CBC_LEGACY:
+		case ENCR_BELT_CBC:
+			oid = OID_BELT_CBC;
+			break;
+		case ENCR_BELT_CFB_LEGACY:
+		case ENCR_BELT_CFB:
+			oid = OID_BELT_CFB;
+			break;
+		case ENCR_BELT_CTR_LEGACY:
+		case ENCR_BELT_CTR:
+			oid = OID_BELT_CTR;
+			break;
 		case ENCR_BLOWFISH:
 			oid = OID_BLOWFISH_CBC;
 			break;
diff -ruN strongswan-5.8.4/src/libstrongswan/crypto/crypters/crypter.h strongswancont-5.8.4-svc/src/libstrongswan/crypto/crypters/crypter.h
--- strongswan-5.8.4/src/libstrongswan/crypto/crypters/crypter.h	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/crypto/crypters/crypter.h	2022-07-06 15:47:34.802984000 +0300
@@ -58,6 +58,11 @@
 	ENCR_CAMELLIA_CCM_ICV12 = 26,
 	ENCR_CAMELLIA_CCM_ICV16 = 27,
 	ENCR_CHACHA20_POLY1305 =  28,
+	
+	ENCR_GOST28147_CFB_LEGACY = 29,
+	ENCR_BELT_CBC_LEGACY =      30,
+	ENCR_BELT_CFB_LEGACY =      31,
+	ENCR_BELT_CTR_LEGACY =      32,
 	ENCR_UNDEFINED =        1024,
 	ENCR_DES_ECB =          1025,
 	ENCR_SERPENT_CBC =      1026,
@@ -65,6 +70,14 @@
 	/* see macros below to handle RC2 (effective) key length */
 	ENCR_RC2_CBC =          1028,
 	ENCR_AES_ECB =			1029,
+	/* BAS */
+	ENCR_GOST28147_CTR =   65530,
+	ENCR_GOST28147_CFB =   65531,
+	ENCR_BELT_CBC =        65532,
+	ENCR_BELT_CFB =        65533,
+	ENCR_BELT_CTR =        65534,
+
+	ENCR_GOST28147_CTR_LEGACY = 65535,
 };
 
 #define DES_BLOCK_SIZE			 8
@@ -73,6 +86,9 @@
 #define CAMELLIA_BLOCK_SIZE		16
 #define SERPENT_BLOCK_SIZE		16
 #define TWOFISH_BLOCK_SIZE		16
+#define GOST_BLOCK_SIZE 		 8
+#define BELT_BLOCK_SIZE 	    16
+#define BELT_IV_SIZE			16
 
 /**
  * For RC2, if the effective key size in bits is not key_size * 8, it should
diff -ruN strongswan-5.8.4/src/libstrongswan/crypto/crypto_factory.c strongswancont-5.8.4-svc/src/libstrongswan/crypto/crypto_factory.c
--- strongswan-5.8.4/src/libstrongswan/crypto/crypto_factory.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/crypto/crypto_factory.c	2023-02-10 16:27:09.793827000 +0300
@@ -57,6 +57,7 @@
 		rng_constructor_t create_rng;
 		nonce_gen_constructor_t create_nonce_gen;
 		dh_constructor_t create_dh;
+		key_tfmer_constructor_t create_key_tfmer;
 		void *create;
 	};
 };
@@ -124,6 +125,11 @@
 	linked_list_t *dhs;
 
 	/**
+	 * registered key transformers, as entry_t
+	 */
+	linked_list_t *transformers;
+
+	/**
 	 * test manager to test crypto algorithms
 	 */
 	crypto_tester_t *tester;
@@ -478,6 +484,32 @@
 	return diffie_hellman;
 }
 
+METHOD(crypto_factory_t, create_key_transformer, key_transformer_t*,
+	private_crypto_factory_t* this, key_transform_alorithm_t algo)
+{
+	enumerator_t *enumerator;
+	entry_t *entry;
+	key_transformer_t *key_transformer = NULL;
+
+	this->lock->read_lock(this->lock);
+	enumerator = this->transformers->create_enumerator(this->transformers);
+	while (enumerator->enumerate(enumerator, &entry))
+	{
+		if (entry->algo == algo)
+		{
+			key_transformer = entry->create_key_tfmer(algo);
+			if (key_transformer)
+			{
+				break;
+			}
+		}
+	}
+	enumerator->destroy(enumerator);
+	this->lock->unlock(this->lock);
+
+	return key_transformer;
+}
+
 /**
  * Insert an algorithm entry to a list
  *
@@ -888,6 +920,34 @@
 	this->lock->unlock(this->lock);
 }
 
+METHOD(crypto_factory_t, add_key_transformer, bool,
+	private_crypto_factory_t *this, key_transform_alorithm_t algo,
+	const char *plugin_name, key_tfmer_constructor_t create)
+{
+	add_entry(this, this->transformers, algo, plugin_name, 0, create);
+	return TRUE;
+}
+
+METHOD(crypto_factory_t, remove_key_transformer, void,
+	private_crypto_factory_t *this, key_tfmer_constructor_t create)
+{
+	entry_t *entry;
+	enumerator_t *enumerator;
+
+	this->lock->write_lock(this->lock);
+	enumerator = this->transformers->create_enumerator(this->transformers);
+	while (enumerator->enumerate(enumerator, &entry))
+	{
+		if (entry->create_key_tfmer == create)
+		{
+			this->transformers->remove_at(this->transformers, enumerator);
+			free(entry);
+		}
+	}
+	enumerator->destroy(enumerator);
+	this->lock->unlock(this->lock);
+}
+
 CALLBACK(entry_match, bool,
 	entry_t *a, va_list args)
 {
@@ -1152,6 +1212,34 @@
 	return create_enumerator(this, this->nonce_gens, nonce_gen_filter);
 }
 
+/**
+ * Filter function to enumerate algorithm, not entry
+ */
+CALLBACK(key_transformer_filter, bool,
+	void *n, enumerator_t *orig, va_list args)
+{
+	entry_t *entry;
+	key_transform_alorithm_t *algo;
+	const char **plugin_name;
+
+	VA_ARGS_VGET(args, algo, plugin_name);
+
+	if (orig->enumerate(orig, &entry))
+	{
+		*algo = entry->algo;
+		*plugin_name = entry->plugin_name;
+		return TRUE;
+	}
+	return FALSE;
+}
+
+METHOD(crypto_factory_t, create_key_transformer_enumerator, enumerator_t*,
+	private_crypto_factory_t *this)
+{
+	return create_enumerator(this, this->transformers, key_transformer_filter);
+}
+
+
 METHOD(crypto_factory_t, add_test_vector, void,
 	private_crypto_factory_t *this, transform_type_t type, void *vector)
 {
@@ -1327,6 +1415,7 @@
 	this->rngs->destroy(this->rngs);
 	this->nonce_gens->destroy(this->nonce_gens);
 	this->dhs->destroy(this->dhs);
+	this->transformers->destroy(this->transformers);
 	this->tester->destroy(this->tester);
 	this->lock->destroy(this->lock);
 	free(this);
@@ -1351,6 +1440,7 @@
 			.create_rng = _create_rng,
 			.create_nonce_gen = _create_nonce_gen,
 			.create_dh = _create_dh,
+			.create_key_transformer = _create_key_transformer,
 			.add_crypter = _add_crypter,
 			.remove_crypter = _remove_crypter,
 			.add_aead = _add_aead,
@@ -1371,6 +1461,8 @@
 			.remove_nonce_gen = _remove_nonce_gen,
 			.add_dh = _add_dh,
 			.remove_dh = _remove_dh,
+			.add_key_transformer = _add_key_transformer,
+			.remove_key_transformer = _remove_key_transformer,
 			.create_crypter_enumerator = _create_crypter_enumerator,
 			.create_aead_enumerator = _create_aead_enumerator,
 			.create_signer_enumerator = _create_signer_enumerator,
@@ -1381,6 +1473,7 @@
 			.create_dh_enumerator = _create_dh_enumerator,
 			.create_rng_enumerator = _create_rng_enumerator,
 			.create_nonce_gen_enumerator = _create_nonce_gen_enumerator,
+			.create_key_transformer_enumerator = _create_key_transformer_enumerator,
 			.add_test_vector = _add_test_vector,
 			.create_verify_enumerator = _create_verify_enumerator,
 			.destroy = _destroy,
@@ -1395,6 +1488,7 @@
 		.rngs = linked_list_create(),
 		.nonce_gens = linked_list_create(),
 		.dhs = linked_list_create(),
+		.transformers = linked_list_create(),
 		.lock = rwlock_create(RWLOCK_TYPE_DEFAULT),
 		.tester = crypto_tester_create(),
 		.test_on_add = lib->settings->get_bool(lib->settings,
diff -ruN strongswan-5.8.4/src/libstrongswan/crypto/crypto_factory.h strongswancont-5.8.4-svc/src/libstrongswan/crypto/crypto_factory.h
--- strongswan-5.8.4/src/libstrongswan/crypto/crypto_factory.h	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/crypto/crypto_factory.h	2022-07-06 15:47:34.810984000 +0300
@@ -36,6 +36,7 @@
 #include <crypto/drbgs/drbg.h>
 #include <crypto/nonce_gen.h>
 #include <crypto/diffie_hellman.h>
+#include <crypto/key_transformer.h>
 #include <crypto/transform.h>
 
 #define CRYPTO_MAX_ALG_LINE          120   /* characters */
@@ -95,6 +96,11 @@
 typedef diffie_hellman_t* (*dh_constructor_t)(diffie_hellman_group_t group, ...);
 
 /**
+ * Constructor function for key transformer
+ */
+typedef key_transformer_t* (*key_tfmer_constructor_t)(key_transform_alorithm_t algo);
+
+/**
  * Handles crypto modules and creates instances.
  */
 struct crypto_factory_t {
@@ -194,6 +200,15 @@
 								   diffie_hellman_group_t group, ...);
 
 	/**
+	 * Create a key transformer instance.
+	 *
+	 * @param algo 			key transform algorithm to use
+	 * @return 				key_transformer_t instance, NULL if not supported
+	 */
+	key_transformer_t* (*create_key_transformer)(crypto_factory_t *this, 
+											key_transform_alorithm_t algo);
+
+	/**
 	 * Register a crypter constructor.
 	 *
 	 * @param algo			algorithm to constructor
@@ -378,6 +393,27 @@
 	void (*remove_dh)(crypto_factory_t *this, dh_constructor_t create);
 
 	/**
+	 * Register key transformer constructor.
+	 *
+	 * @param algo			algorithm to constructor
+	 * @param plugin_name	plugin that registered this algorithm
+	 * @param create		constructor function for that algorithm
+	 * @return				TRUE if registered, FALSE if test vector failed
+	 */
+	bool (*add_key_transformer)(crypto_factory_t *this,
+								key_transform_alorithm_t algo, 
+								const char *plugin_name,
+								key_tfmer_constructor_t create);
+
+	/**
+	 * Unregister key transformer constructor.
+	 *
+	 * @param create		constructor function to unregiste
+	 */
+	void (*remove_key_transformer)(crypto_factory_t *this,
+								key_tfmer_constructor_t create);
+
+	/**
 	 * Create an enumerator over all registered crypter algorithms.
 	 *
 	 * @return				enumerator over encryption_algorithm_t, plugin
@@ -448,6 +484,13 @@
 	enumerator_t* (*create_nonce_gen_enumerator)(crypto_factory_t *this);
 
 	/**
+	 * Create an enumerator over all registered key transformers.
+	 *
+	 * @return				enumerator over key_transform_alorithm_t, plugin
+	 */
+	enumerator_t* (*create_key_transformer_enumerator)(crypto_factory_t *this);
+
+	/**
 	 * Add a test vector to the crypto factory.
 	 *
 	 * @param type			type of the test vector
diff -ruN strongswan-5.8.4/src/libstrongswan/crypto/crypto_tester.c strongswancont-5.8.4-svc/src/libstrongswan/crypto/crypto_tester.c
--- strongswan-5.8.4/src/libstrongswan/crypto/crypto_tester.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/crypto/crypto_tester.c	2023-05-15 14:47:42.540788000 +0300
@@ -287,7 +287,7 @@
 		}
 		if (failed)
 		{
-			DBG1(DBG_LIB, "disabled %N[%s]: %s test vector failed",
+			DBG2(DBG_LIB, "disabled %N[%s]: %s test vector failed",
 				 encryption_algorithm_names, alg, plugin_name, get_name(vector));
 			break;
 		}
@@ -297,13 +297,13 @@
 	{
 		if (failed)
 		{
-			DBG1(DBG_LIB,"disable %N[%s]: %zd byte key size not supported",
+			DBG2(DBG_LIB,"disable %N[%s]: %zd byte key size not supported",
 				 encryption_algorithm_names, alg, plugin_name, key_size);
 			return FALSE;
 		}
 		else
 		{
-			DBG1(DBG_LIB, "%s %N[%s]: no test vectors found",
+			DBG2(DBG_LIB, "%s %N[%s]: no test vectors found",
 				 this->required ? "disabled" : "enabled ",
 				 encryption_algorithm_names, alg, plugin_name);
 			return !this->required;
@@ -314,13 +314,13 @@
 		if (speed)
 		{
 			*speed = bench_crypter(this, alg, create, key_size);
-			DBG1(DBG_LIB, "enabled  %N[%s]: passed %u test vectors, %d points "
+			DBG2(DBG_LIB, "enabled  %N[%s]: passed %u test vectors, %d points "
 				 "(%zd bit key)", encryption_algorithm_names, alg,
 				 plugin_name, tested, *speed, key_size * 8);
 		}
 		else
 		{
-			DBG1(DBG_LIB, "enabled  %N[%s]: passed %u test vectors",
+			DBG2(DBG_LIB, "enabled  %N[%s]: passed %u test vectors",
 				 encryption_algorithm_names, alg, plugin_name, tested);
 		}
 	}
@@ -417,7 +417,7 @@
 		aead = create(alg, vector->key_size, vector->salt_size);
 		if (!aead)
 		{
-			DBG1(DBG_LIB, "%N[%s]: %u bit key size not supported",
+			DBG2(DBG_LIB, "%N[%s]: %u bit key size not supported",
 				 encryption_algorithm_names, alg, plugin_name,
 				 BITS_PER_BYTE * vector->key_size);
 			continue;
@@ -482,7 +482,7 @@
 		}
 		if (failed)
 		{
-			DBG1(DBG_LIB, "disabled %N[%s]: %s test vector failed",
+			DBG2(DBG_LIB, "disabled %N[%s]: %s test vector failed",
 				 encryption_algorithm_names, alg, plugin_name, get_name(vector));
 			break;
 		}
@@ -492,13 +492,13 @@
 	{
 		if (failed)
 		{
-			DBG1(DBG_LIB,"disable %N[%s]: %zd byte key size not supported",
+			DBG2(DBG_LIB,"disable %N[%s]: %zd byte key size not supported",
 				 encryption_algorithm_names, alg, plugin_name, key_size);
 			return FALSE;
 		}
 		else
 		{
-			DBG1(DBG_LIB, "%s %N[%s]: no test vectors found",
+			DBG2(DBG_LIB, "%s %N[%s]: no test vectors found",
 				 this->required ? "disabled" : "enabled ",
 				 encryption_algorithm_names, alg, plugin_name);
 			return !this->required;
@@ -509,13 +509,13 @@
 		if (speed)
 		{
 			*speed = bench_aead(this, alg, create, key_size);
-			DBG1(DBG_LIB, "enabled  %N[%s]: passed %u test vectors, %d points "
+			DBG2(DBG_LIB, "enabled  %N[%s]: passed %u test vectors, %d points "
 				 "(%zd bit key)", encryption_algorithm_names, alg,
 				 plugin_name, tested, *speed, key_size * 8);
 		}
 		else
 		{
-			DBG1(DBG_LIB, "enabled  %N[%s]: passed %u test vectors",
+			DBG2(DBG_LIB, "enabled  %N[%s]: passed %u test vectors",
 				 encryption_algorithm_names, alg, plugin_name, tested);
 		}
 	}
@@ -594,7 +594,7 @@
 		signer = create(alg);
 		if (!signer)
 		{
-			DBG1(DBG_LIB, "disabled %N[%s]: creating instance failed",
+			DBG2(DBG_LIB, "disabled %N[%s]: creating instance failed",
 				 integrity_algorithm_names, alg, plugin_name);
 			break;
 		}
@@ -674,7 +674,7 @@
 		chunk_free(&mac);
 		if (failed)
 		{
-			DBG1(DBG_LIB, "disabled %N[%s]: %s test vector failed",
+			DBG2(DBG_LIB, "disabled %N[%s]: %s test vector failed",
 				 integrity_algorithm_names, alg, plugin_name, get_name(vector));
 			break;
 		}
@@ -682,7 +682,7 @@
 	enumerator->destroy(enumerator);
 	if (!tested)
 	{
-		DBG1(DBG_LIB, "%s %N[%s]: no test vectors found",
+		DBG2(DBG_LIB, "%s %N[%s]: no test vectors found",
 			 this->required ? "disabled" : "enabled ",
 			 integrity_algorithm_names, alg, plugin_name);
 		return !this->required;
@@ -692,12 +692,12 @@
 		if (speed)
 		{
 			*speed = bench_signer(this, alg, create);
-			DBG1(DBG_LIB, "enabled  %N[%s]: passed %u test vectors, %d points",
+			DBG2(DBG_LIB, "enabled  %N[%s]: passed %u test vectors, %d points",
 				 integrity_algorithm_names, alg, plugin_name, tested, *speed);
 		}
 		else
 		{
-			DBG1(DBG_LIB, "enabled  %N[%s]: passed %u test vectors",
+			DBG2(DBG_LIB, "enabled  %N[%s]: passed %u test vectors",
 				 integrity_algorithm_names, alg, plugin_name, tested);
 		}
 	}
@@ -765,7 +765,7 @@
 		hasher = create(alg);
 		if (!hasher)
 		{
-			DBG1(DBG_LIB, "disabled %N[%s]: creating instance failed",
+			DBG2(DBG_LIB, "disabled %N[%s]: creating instance failed",
 				 hash_algorithm_names, alg, plugin_name);
 			break;
 		}
@@ -830,7 +830,7 @@
 		chunk_free(&hash);
 		if (failed)
 		{
-			DBG1(DBG_LIB, "disabled %N[%s]: %s test vector failed",
+			DBG2(DBG_LIB, "disabled %N[%s]: %s test vector failed",
 				 hash_algorithm_names, alg, plugin_name, get_name(vector));
 			break;
 		}
@@ -838,7 +838,7 @@
 	enumerator->destroy(enumerator);
 	if (!tested)
 	{
-		DBG1(DBG_LIB, "%s %N[%s]: no test vectors found",
+		DBG2(DBG_LIB, "%s %N[%s]: no test vectors found",
 			 this->required ? "disabled" : "enabled ",
 			 hash_algorithm_names, alg, plugin_name);
 		return !this->required;
@@ -848,12 +848,12 @@
 		if (speed)
 		{
 			*speed = bench_hasher(this, alg, create);
-			DBG1(DBG_LIB, "enabled  %N[%s]: passed %u test vectors, %d points",
+			DBG2(DBG_LIB, "enabled  %N[%s]: passed %u test vectors, %d points",
 				 hash_algorithm_names, alg, plugin_name, tested, *speed);
 		}
 		else
 		{
-			DBG1(DBG_LIB, "enabled  %N[%s]: passed %u test vectors",
+			DBG2(DBG_LIB, "enabled  %N[%s]: passed %u test vectors",
 				 hash_algorithm_names, alg, plugin_name, tested);
 		}
 	}
@@ -928,7 +928,7 @@
 		prf = create(alg);
 		if (!prf)
 		{
-			DBG1(DBG_LIB, "disabled %N[%s]: creating instance failed",
+			DBG2(DBG_LIB, "disabled %N[%s]: creating instance failed",
 				 pseudo_random_function_names, alg, plugin_name);
 			break;
 		}
@@ -1016,7 +1016,7 @@
 		chunk_free(&out);
 		if (failed)
 		{
-			DBG1(DBG_LIB, "disabled %N[%s]: %s test vector failed",
+			DBG2(DBG_LIB, "disabled %N[%s]: %s test vector failed",
 				 pseudo_random_function_names, alg, plugin_name, get_name(vector));
 			break;
 		}
@@ -1024,7 +1024,7 @@
 	enumerator->destroy(enumerator);
 	if (!tested)
 	{
-		DBG1(DBG_LIB, "%s %N[%s]: no test vectors found",
+		DBG2(DBG_LIB, "%s %N[%s]: no test vectors found",
 			 this->required ? "disabled" : "enabled ",
 			 pseudo_random_function_names, alg, plugin_name);
 		return !this->required;
@@ -1034,12 +1034,12 @@
 		if (speed)
 		{
 			*speed = bench_prf(this, alg, create);
-			DBG1(DBG_LIB, "enabled  %N[%s]: passed %u test vectors, %d points",
+			DBG2(DBG_LIB, "enabled  %N[%s]: passed %u test vectors, %d points",
 				 pseudo_random_function_names, alg, plugin_name, tested, *speed);
 		}
 		else
 		{
-			DBG1(DBG_LIB, "enabled  %N[%s]: passed %u test vectors",
+			DBG2(DBG_LIB, "enabled  %N[%s]: passed %u test vectors",
 				 pseudo_random_function_names, alg, plugin_name, tested);
 		}
 	}
@@ -1110,7 +1110,7 @@
 		xof = create(alg);
 		if (!xof)
 		{
-			DBG1(DBG_LIB, "disabled %N[%s]: creating instance failed",
+			DBG2(DBG_LIB, "disabled %N[%s]: creating instance failed",
 				 ext_out_function_names, alg, plugin_name);
 			break;
 		}
@@ -1156,7 +1156,7 @@
 		chunk_free(&out);
 		if (failed)
 		{
-			DBG1(DBG_LIB, "disabled %N[%s]: %s test vector failed",
+			DBG2(DBG_LIB, "disabled %N[%s]: %s test vector failed",
 				 ext_out_function_names, alg, plugin_name, get_name(vector));
 			break;
 		}
@@ -1164,7 +1164,7 @@
 	enumerator->destroy(enumerator);
 	if (!tested)
 	{
-		DBG1(DBG_LIB, "%s %N[%s]: no test vectors found",
+		DBG2(DBG_LIB, "%s %N[%s]: no test vectors found",
 			 this->required ? "disabled" : "enabled ",
 			 ext_out_function_names, alg, plugin_name);
 		return !this->required;
@@ -1174,12 +1174,12 @@
 		if (speed)
 		{
 			*speed = bench_xof(this, alg, create);
-			DBG1(DBG_LIB, "enabled  %N[%s]: passed %u test vectors, %d points",
+			DBG2(DBG_LIB, "enabled  %N[%s]: passed %u test vectors, %d points",
 				 ext_out_function_names, alg, plugin_name, tested, *speed);
 		}
 		else
 		{
-			DBG1(DBG_LIB, "enabled  %N[%s]: passed %u test vectors",
+			DBG2(DBG_LIB, "enabled  %N[%s]: passed %u test vectors",
 				 ext_out_function_names, alg, plugin_name, tested);
 		}
 	}
@@ -1253,7 +1253,7 @@
 					  vector->personalization_str);
 		if (!drbg)
 		{
-			DBG1(DBG_LIB, "disabled %N[%s]: creating instance failed",
+			DBG2(DBG_LIB, "disabled %N[%s]: creating instance failed",
 				 drbg_type_names, type, plugin_name);
 			entropy->destroy(entropy);
 			chunk_free(&out);
@@ -1282,7 +1282,7 @@
 		chunk_free(&out);
 		if (failed)
 		{
-			DBG1(DBG_LIB, "disabled %N[%s]: %s test vector failed",
+			DBG2(DBG_LIB, "disabled %N[%s]: %s test vector failed",
 				 drbg_type_names, type, plugin_name, get_name(vector));
 			break;
 		}
@@ -1290,7 +1290,7 @@
 	enumerator->destroy(enumerator);
 	if (!tested)
 	{
-		DBG1(DBG_LIB, "%s %N[%s]: no test vectors found",
+		DBG2(DBG_LIB, "%s %N[%s]: no test vectors found",
 			 this->required ? "disabled" : "enabled ",
 			 drbg_type_names, type, plugin_name);
 		return !this->required;
@@ -1300,12 +1300,12 @@
 		if (speed)
 		{
 			*speed = bench_drbg(this, type, create);
-			DBG1(DBG_LIB, "enabled  %N[%s]: passed %u test vectors, %d points",
+			DBG2(DBG_LIB, "enabled  %N[%s]: passed %u test vectors, %d points",
 				 drbg_type_names, type, plugin_name, tested, *speed);
 		}
 		else
 		{
-			DBG1(DBG_LIB, "enabled  %N[%s]: passed %u test vectors",
+			DBG2(DBG_LIB, "enabled  %N[%s]: passed %u test vectors",
 				 drbg_type_names, type, plugin_name, tested);
 		}
 	}
@@ -1499,7 +1499,7 @@
 			DESTROY_IF(b);
 			failed = TRUE;
 			tested++;
-			DBG1(DBG_LIB, "disabled %N[%s]: creating instance failed",
+			DBG2(DBG_LIB, "disabled %N[%s]: creating instance failed",
 				 diffie_hellman_group_names, group, plugin_name);
 			break;
 		}
@@ -1556,7 +1556,7 @@
 		chunk_free(&bsec);
 		if (failed)
 		{
-			DBG1(DBG_LIB, "disabled %N[%s]: %s test vector failed",
+			DBG2(DBG_LIB, "disabled %N[%s]: %s test vector failed",
 				 diffie_hellman_group_names, group, plugin_name, get_name(v));
 			break;
 		}
@@ -1564,7 +1564,7 @@
 	enumerator->destroy(enumerator);
 	if (!tested)
 	{
-		DBG1(DBG_LIB, "%s %N[%s]: no test vectors found / untestable",
+		DBG2(DBG_LIB, "%s %N[%s]: no test vectors found / untestable",
 			 this->required ? "disabled" : "enabled ",
 			 diffie_hellman_group_names, group, plugin_name);
 		return !this->required;
@@ -1574,12 +1574,12 @@
 		if (speed)
 		{
 			*speed = bench_dh(this, group, create);
-			DBG1(DBG_LIB, "enabled  %N[%s]: passed %u test vectors, %d points",
+			DBG2(DBG_LIB, "enabled  %N[%s]: passed %u test vectors, %d points",
 				 diffie_hellman_group_names, group, plugin_name, tested, *speed);
 		}
 		else
 		{
-			DBG1(DBG_LIB, "enabled  %N[%s]: passed %u test vectors",
+			DBG2(DBG_LIB, "enabled  %N[%s]: passed %u test vectors",
 				 diffie_hellman_group_names, group, plugin_name, tested);
 		}
 	}
diff -ruN strongswan-5.8.4/src/libstrongswan/crypto/diffie_hellman.c strongswancont-5.8.4-svc/src/libstrongswan/crypto/diffie_hellman.c
--- strongswan-5.8.4/src/libstrongswan/crypto/diffie_hellman.c	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/crypto/diffie_hellman.c	2022-07-06 15:47:34.802984000 +0300
@@ -53,11 +53,12 @@
 	"NTRU_256");
 ENUM_NEXT(diffie_hellman_group_names, NH_128_BIT, NH_128_BIT, NTRU_256_BIT,
 	"NEWHOPE_128");
-ENUM_NEXT(diffie_hellman_group_names, MODP_CUSTOM, MODP_CUSTOM, NH_128_BIT,
+ENUM_NEXT(diffie_hellman_group_names, ECP_256_BIGN, ECP_256_BIGN, NH_128_BIT,
+	"ECP_256_BIGN");
+ENUM_NEXT(diffie_hellman_group_names, MODP_CUSTOM, MODP_CUSTOM, ECP_256_BIGN,
 	"MODP_CUSTOM");
 ENUM_END(diffie_hellman_group_names, MODP_CUSTOM);
 
-
 /**
  * List of known diffie hellman group parameters.
  */
@@ -493,6 +494,7 @@
 		case ECP_256_BP:
 		case ECP_384_BP:
 		case ECP_512_BP:
+		case ECP_256_BIGN:
 			return TRUE;
 		default:
 			return FALSE;
@@ -526,6 +528,9 @@
 				valid = value.len == params->prime.len;
 			}
 			break;
+		//case ECP_256_BIGN:
+		//	valid = value.len == 64;
+		//	break;
 		case ECP_192_BIT:
 			valid = value.len == 48;
 			break;
diff -ruN strongswan-5.8.4/src/libstrongswan/crypto/diffie_hellman.h strongswancont-5.8.4-svc/src/libstrongswan/crypto/diffie_hellman.h
--- strongswan-5.8.4/src/libstrongswan/crypto/diffie_hellman.h	2020-03-29 11:59:15.000000000 +0300
+++ strongswancont-5.8.4-svc/src/libstrongswan/crypto/diffie_hellman.h	2022-07-06 15:47:34.790983000 +0300
@@ -72,6 +72,7 @@
 	NTRU_192_BIT = 1032,
 	NTRU_256_BIT = 1033,
 	NH_128_BIT   = 1040,
+	ECP_256_BIGN = 65201,
 	/** internally used DH group with additional parameters g and p, outside
 	 * of PRIVATE USE (i.e. IKEv2 DH group range) so it can't be negotiated */
 	MODP_CUSTOM = 65536,
